# -*- coding: utf-8 -*-
"""
Файл задач для celery.
"""
import logging
import traceback
from djcelery import celery
from fill_kladr import fill_kladr
from updater import KLADRUpdater, KLADRUpdaterException
logger = logging.getLogger('celery.task')


@celery.task
def add(x, y):
    return x + y


@celery.task
def run_update(context):
    """Запуск обновления справочника КЛАДР.

    @param context: контекст для таска
    """
    result = KLADRUpdater.FAIL
    error_msg = None
    try:
        updater = KLADRUpdater(context.load_type, context.archive_file)
        updater.unzip_dbf_files()
        fill_kladr(dbf_path=updater.file_dir,
                   clear_before=getattr(context, 'clear_before', False),
                   update=getattr(context, 'update', True))
        updater.clean()
        result = KLADRUpdater.SUCCESS

    except KLADRUpdaterException, err:
        error_msg = unicode(err)

    except Exception, err:
        logger.error(traceback.format_exc())
        error_msg = unicode(err)

    return result, error_msg
